<!DOCTYPE html>
<html lang="en-us">
   <head>
      <title>Heapsort Experiment</title>
      <meta name="viewport" content="width=device-width,height=device-height,initial-scale=1.0" />
      <meta charset="utf-8" />
      <style>
         .exp {
         display: none;
         }
         table {
         font-family: arial, sans-serif;
         border-collapse: collapse;
         width: 100%;
         text-align: center;
         }
         th {
         background-color:#2780C6;
         text-align: center !important;
         color:#fff;
         }
         #headings {
         background-color:#2780C6;
         text-align: center;
         color:#fff;
         }
         td {
         border: 1px solid #dddddd;
         padding: 8px;
         text-align: center;
         height:20px;
         }
         tr:hover {
         background-color: #ddd;
         }
      </style>
      <!-- Google Tag Manager -->
      <script class="gtm">
        window.dataLayer = window.dataLayer || [];

        window.dataLayer.push ({
        'labName': 'Data Structures – 1',
        'discipline': 'Computer Science and Engineering',
        'college': 'IIITH',
        'phase': '3',
        'expName': 'Heap Sort',
        'expShortName': 'heap-sort'
        });
        

        (function(w,d,s,l,i){w[l]=w[l]||[];w[l].push({'gtm.start':
        new Date().getTime(),event:'gtm.js'});var
        f=d.getElementsByTagName(s)[0],
        j=d.createElement(s),dl=l!='dataLayer'?'&l='+l:'';j.async=true;j.src=
        'https://www.googletagmanager.com/gtm.js?id='+i+dl;f.parentNode.insertBefore(j,f);
        })(window,document,'script','dataLayer','GTM-W59SWTR');
      </script>
      <!-- End Google Tag Manager -->

   </head>
   <body>
     <!-- Google Tag Manager (noscript) -->
     <noscript class="gtm">
       <iframe height="0" width="0"
         src="https://www.googletagmanager.com/ns.html?id=GTM-W59SWTR"
         style="display:none;visibility:hidden">
       </iframe>
     </noscript>
     <!-- End Google Tag Manager (noscript) -->

      <div class="exp" title="Heapsort">
         <div class="longt">
            <h1 class="hlongt">Introduction to Heapsort</h1>
         </div>
         <div class="preamble">
            <div class="art txt" title="Estimation">
               <div class="longt">
                  <h2 class="hlongt">Estimated Time</h2>
               </div>
               <div class="art-body">
                  <p>1 hour</p>
               </div>
            </div>
            <div class="art req" title="Introduction Video">
               <div class="longt">
                  <h2 class="hlongt">A Short Introduction to the Overall Experiment</h2>
               </div>
               <div class="description">
                  <p>
                     Introduction to the overall
                     experiment in the form of a
                     video has to be displayed
                     here!
                  </p>
               </div>
            </div>
            <div class="art txt" title="Prerequisites">
               <div class="longt">
                  <h2 class="hlongt">Prerequisites of the Experiment</h2>
               </div>
               <div class="art-body">
                  <ul>
                     <li>Basic knowledge on <a href="https://en.wikipedia.org/wiki/Sorting_algorithm">sorting</a>,
                        a <a href="https://en.wikipedia.org/wiki/Binary_tree">binary
                        tree</a> and a <a href="https://en.wikipedia.org/wiki/Logarithm">logarithm</a>
                     </li>
                     <li>And above all, a curiosity to learn and explore!</li>
                  </ul>
               </div>
            </div>
            <div class="art txt" title="Overview">
               <div class="longt">
                  <h2 class="hlongt">Overview of the Experiment</h2>
               </div>
               <div class="art-body">
                  <p>The experiment features a series
                     of modules with video lectures,
                     hands-on practice exercises and
                     quizzes for self analysis.
                  </p>
               </div>
            </div>
            <div class="art txt" title="Learning Objectives">
               <div class="longt">
                  <h2 class="hlongt">Learning Objectives of the Experiment</h2>
               </div>
               <div class="art-body">
                  <p>In this experiment, we will be able to do the following:<br>
                  <ul>
                     <li>Demonstrate understanding of
                        the concepts of inserting
                        elements into the heap, extract
                        max operation and the rebuild
                        operation in heapsort as key
                        operations in heap sort
                     </li>
                     <li>Given an unsorted array of
                        numbers, generate a sorted array
                        of numbers by applying heapsort
                     </li>
                     <li>Understand HeapSort operations
                        and associated time complexity
                        through interactive animations
                     </li>
                     <li>Demonstrate knowledge of time
                        complexity of heapsort by
                        counting the number of
                        operations involved in inserting
                        heap and removing the root till
                        the array becomes sorted
                        (heapify operation)
                     </li>
                  </ul>
                  </p>
               </div>
            </div>
            <div class="art txt" title="Modules and Weightage">
               <div class="longt">
                  <h2 class="hlongt">Experiment Modules and their Weightage</h2>
               </div>
               <div class="art-body">
                  <table>
                     <thead>
                        <tr>
                           <th>Module</th>
                           <th>Weightage</th>
                           <th>Expectation</th>
                        </tr>
                     </thead>
                     <tbody>
                        <tr>
                           <td>Pre-Test</td>
                           <td>10%</td>
                           <td>Solve All Questions</td>
                        </tr>
                        <tr>
                           <td>Insert operation</td>
                           <td>20%</td>
                           <td>Practice atleast five questions</td>
                        </tr>
                        <tr>
                           <td>Extract operation</td>
                           <td>10%</td>
                           <td>Practice atleast two questions</td>
                        </tr>
                        <tr>
                           <td>Heap Sort</td>
                           <td>20%</td>
                           <td>Understand all operations</td>
                        </tr>
                        <tr>
                           <td>Post-test</td>
                           <td>20%</td>
                           <td>Solve all Questions</td>
                        </tr>
                     </tbody>
                  </table>
               </div>
            </div>
         </div>
         <div class="lu" title="Pre-Test">
            <div class="longt">
               <h1 class="hlongt">Pre-Test of the Experiment</h1>
            </div>
            <div class="preamble">
               <div class="art txt" title="Estimation">
                  <div class="longt">
                     <h2 class="hlongt">Estimated Time</h2>
                  </div>
                  <div class="art-body">
                     <p>10 minutes</p>
                  </div>
               </div>
               <div class="art txt" title="Instructions">
                  <div class="longt">
                     <h2 class="hlongt">Instructions for Pre-Test</h2>
                  </div>
                  <div class="art-body">
                     <p>Pretest includes questions on
                        sorting, binary trees and
                        logarithms. Read the
                        questions in the quiz section
                        and select the correct option
                        from the ones
                        provided. Please note that
                        some questions may have more
                        than one correct response.
                     </p>
                  </div>
               </div>
            </div>
            <div class="quiz" title="Pre-Test Quiz">
               <div class="longt">
                  <h2 class="hlongt">A Quiz with Pre-Test</h2>
               </div>
               <div class="mcq">
                  <div class="preamble">
                     <div class="art txt" title="question1">
                        <div class="art-body">
                           <p>Q1. The array 5, 4,
                              1, 2, 3 is sorted in
                              ascending order. Which
                              option provides the
                              correctly sorted array?
                           </p>
                        </div>
                        s
                     </div>
                  </div>
                  <div class="choice" data-correct="true">
                     <div class="preamble">
                        <div class="art txt" title="q1-c1">
                           <div class="art-body">
                              <p>(A) 1, 2, 3, 4, 5</p>
                           </div>
                        </div>
                     </div>
                  </div>
                  <div class="choice" data-correct="false">
                     <div class="preamble">
                        <div class="art txt" title="q1-c2">
                           <div class="art-body">
                              <p>(B) 5, 4, 3, 2, 1</p>
                           </div>
                        </div>
                     </div>
                  </div>
                  <div class="choice" data-correct="false">
                     <div class="preamble">
                        <div class="art txt" title="q1-c3">
                           <div class="art-body">
                              <p>(C) 1, 1, 2, 2, 3, 3, 4, 4, 5, 5</p>
                           </div>
                        </div>
                     </div>
                  </div>
                  <div class="choice" data-correct="false">
                     <div class="preamble">
                        <div class="art txt" title="q1-c4">
                           <div class="art-body">
                              <p>(D) Depends on which data structure is used</p>
                           </div>
                        </div>
                     </div>
                  </div>
                  <div class="explanation">
                     <div class="art txt" title="Explanation">
                        <div class="art-body">
                           <p>An array is defined as sorted if all its elements are either
                              in ascending or descending order.
                           </p>
                        </div>
                     </div>
                  </div>
               </div>
               <div class="mcq">
                  <div class="preamble">
                     <div class="art txt" title="question2">
                        <div class="art-body">
                           <p>Q2. Which of the following statements is correct?</p>
                        </div>
                     </div>
                  </div>
                  <div class="choice" data-correct="false">
                     <div class="preamble">
                        <div class="art txt" title="q2-c1">
                           <div class="art-body">
                              <p>(A) Log210 is smaller than log310</p>
                           </div>
                        </div>
                     </div>
                  </div>
                  <div class="choice" data-correct="false">
                     <div class="preamble">
                        <div class="art txt" title="q2-c2">
                           <div class="art-body">
                              <p>(B) Loge 2 is the same as Log2 e</p>
                           </div>
                        </div>
                     </div>
                  </div>
                  <div class="choice" data-correct="true">
                     <div class="preamble">
                        <div class="art txt" title="q2-c3">
                           <div class="art-body">
                              <p>(C) Log216 is the same as sqrt (16)</p>
                           </div>
                        </div>
                     </div>
                  </div>
                  <div class="choice" data-correct="false">
                     <div class="preamble">
                        <div class="art txt" title="q2-c4">
                           <div class="art-body">
                              <p>(D) Log1010 is larger than Log2 2
                              </p>
                           </div>
                        </div>
                     </div>
                  </div>
                  <div class="explanation">
                     <div class="art txt" title="Explanation">
                        <div class="art-body">
                           <p>Basic properties of logarithm
                           </p>
                        </div>
                     </div>
                  </div>
               </div>
               <div class="mcq">
                  <div class="preamble">
                     <div class="art txt" title="question3">
                        <div class="art-body">
                           <p>Q3. Which of the following is true about Binary Trees?</p>
                        </div>
                     </div>
                  </div>
                  <div class="choice" data-correct="false">
                     <div class="preamble">
                        <div class="art txt" title="q2-c1">
                           <div class="art-body">
                              <p>(A) Every binary tree is either complete or full</p>
                           </div>
                        </div>
                     </div>
                  </div>
                  <div class="choice" data-correct="false">
                     <div class="preamble">
                        <div class="art txt" title="q2-c2">
                           <div class="art-body">
                              <p>(B) Every complete binary tree is also a full binary tree
                              </p>
                           </div>
                        </div>
                     </div>
                  </div>
                  <div class="choice" data-correct="true">
                     <div class="preamble">
                        <div class="art txt" title="q2-c3">
                           <div class="art-body">
                              <p>(C) Every full binary tree is also a complete binary tree
                              </p>
                           </div>
                        </div>
                     </div>
                  </div>
                  <div class="choice" data-correct="false">
                     <div class="preamble">
                        <div class="art txt" title="q2-c4">
                           <div class="art-body">
                              <p>(D) No binary tree is both complete and full</p>
                           </div>
                        </div>
                     </div>
                  </div>
                  <div class="choice" data-correct="false">
                     <div class="preamble">
                        <div class="art txt" title="q2-c4">
                           <div class="art-body">
                              <p>(E) None of the above</p>
                           </div>
                        </div>
                     </div>
                  </div>
                  <div class="explanation">
                     <div class="art txt" title="Explanation">
                        <div class="art-body">
                           <p>A full binary tree is also complete owing to its properties
                           </p>
                        </div>
                     </div>
                  </div>
               </div>
               <div class="mcq">
                  <div class="preamble">
                     <div class="art txt" title="question4">
                        <div class="art-body">
                           <p>Q4. Level of a node is distance from root to that node. For
                              example, level of root is 1 and levels of left and right
                              children of root is 2. The maximum number of nodes on
                              level i of a binary tree is <br>
                              In the following answers, the operator '^' indicates
                              power.
                           </p>
                        </div>
                     </div>
                  </div>
                  <div class="choice" data-correct="true">
                     <div class="preamble">
                        <div class="art txt" title="q2-c1">
                           <div class="art-body">
                              <p>(A) 2^(i-1)</p>
                           </div>
                        </div>
                     </div>
                  </div>
                  <div class="choice" data-correct="false">
                     <div class="preamble">
                        <div class="art txt" title="q2-c2">
                           <div class="art-body">
                              <p>(B) 2^i</p>
                           </div>
                        </div>
                     </div>
                  </div>
                  <div class="choice" data-correct="false">
                     <div class="preamble">
                        <div class="art txt" title="q2-c3">
                           <div class="art-body">
                              <p>(C) 2^(i+1)</p>
                           </div>
                        </div>
                     </div>
                  </div>
                  <div class="choice" data-correct="false">
                     <div class="preamble">
                        <div class="art txt" title="q2-c4">
                           <div class="art-body">
                              <p>(D) 2^[(i+1)/2]</p>
                           </div>
                        </div>
                     </div>
                  </div>
                  <div class="explanation">
                     <div class="art txt" title="Explanation">
                        <div class="art-body">
                           <p>Level 1 has 1 node, level 2 has 2 nodes, level 3 has 4 and
                              so on.
                           </p>
                        </div>
                     </div>
                  </div>
               </div>
            </div>
            <div class="task" title="Recap">
               <div class="longt">
                  <h2 class="hlongt">Overview of Heap Sort</h2>
               </div>
               <div class="art txt" title="What are Heaps">
                  <div class="longt">
                     <h2 class="hlongt">What are Heaps (Min-Heaps)?</h2>
                  </div>
                  <div class="art-body">
                     <p>A heap is a data structure where the lowest element
                        is at the top. A heap is a full left-justified binary tree in
                        <b>which every element is greater than both it's children.</b>
                        It allows for insertion and
                        deletion in O(log n). A heap
                        can be built from an array
                        fastest in O(n) time.
                     </p>
                  </div>
               </div>
               <div class="art txt" title="How to Heap Sort">
                  <div class="longt">
                     <h2 class="hlongt">How to Sort</h2>
                  </div>
                  <div class="art-body">
                     <p>Sorting an array using a Heap involves the following steps.</p>
                     <ul>
                        <li><b>Insert</b> all Elements from the Array into the Heap.</li>
                        <li><b>Extract</b> the smallest element each time till the heap is
                           empty.
                        </li>
                     </ul>
                     <p>For this, we want to learn
                        the Insert and Extract
                        operation into the
                        heap. Repeated Insert and
                        Extract-Min will result in a
                        sorted array in O(n log n)
                        time.
                     </p>
                  </div>
               </div>
            </div>
         </div>
         <div class="lu" title="Insert Heap">
            <div class="longt">
               <h2 class="hlongt">Operation on Insert Heap</h2>
            </div>
            <div class="preamble">
               <div class="art txt" title="Estimation">
                  <div class="longt">
                     <h2 class="hlongt">Estimated Time</h2>
                  </div>
                  <div class="art-body">
                     <p>15 minutes</p>
                  </div>
               </div>
               <div class="art req" title="Insert Concept">
                  <div class="longt">
                     <h2 class="hlongt">Concept of Insert Heap</h2>
                  </div>
                  <div class="description">
                     <p>
                        Video should be present here which explains Insert Heap
                     </p>
                  </div>
               </div>
               <div class="art txt" title="Learning Objectives">
                  <div class="longt">
                     <h2 class="hlongt">Learning Objectives of this Module:</h2>
                  </div>
                  <div class="art-body">
                     <p>Welcome to this module on insert!
                        Take a look at what you will go
                        through the module.
                     <ul>
                        <li>The process of inserting
                           elements into max heap
                        </li>
                        <li>Practice inserting
                           elements into max heap
                        </li>
                        <li>A quiz to check your
                           understanding of
                           inserting elements into
                           a heap
                        </li>
                     </ul>
                     </p>
                  </div>
               </div>
            </div>
            <div class="task" title="Insert Heap Process">
               <div class="longt">
                  <h2 class="hlongt">Process of Inserting Elements into Heap</h2>
               </div>
               <div class="art txt" title="Theory">
                  <div class="longt">
                     <h2 class="hlongt">Theory of Insert Heap</h2>
                  </div>
                  <div class="art-body">
                     <p>In min heap the parent node is
                        always less than both its
                        children. In a max heap the
                        parent node is always greater
                        than both its children.
                     </p>
                  </div>
               </div>
               <div class="art txt" title="Algorithmic Description">
                  <div class="longt">
                     <h2 class="hlongt">Algorithmic Description of Insert Heap</h2>
                  </div>
                  <div class="art-body">
                     <p>Building a heap is a process
                        through which an array of
                        elements in any given order is
                        converted to a min heap or a max
                        heap.<br>Followings are the steps
                        to insert elements into Heap: <br>
                     <ul>
                        <li>Input array A with n elements.</li>
                        <li>
                           One by one, the array elements
                           are inserted into 
                           <th></th>
                           e
                           heap at the leaf position.
                        </li>
                        <li>After every insersion heap
                           property is checked and if heap
                           propety is violated, then we shift
                           up the inserted element to get a
                           heap.
                        </li>
                     </ul>
                     </p>
                  </div>
               </div>
               <div class="art req" title="Image: Insert Heap Representation">
                  <div class="longt">
                     <h2 class="hlongt">Pictorial Representation of Insert Heap Operation
                     </h2>
                  </div>
                  <div class="description">
                     <p>
                        A flow diagram above depicts the
                        insert operation, from left to
                        right with the following
                        elements.
                     </p>
                  </div>
               </div>
               <!--div class="art req" title="Insertion of Max Heap Video">
                  <div class="longt">
                     <h2 class="hlongt">Video Demonstration of Inserting Elements into
                        Max Heap
                     </h2>
                  </div>
                  <div class="description">
                     <p>Insert Max heap video should be present here
                     </p>
                  </div>
               </div-->
            </div>
            <div class="task" title="Demo: Insertion in Heaps">
               <div class="longt">
                  <h2 class="hlongt">Demo of Insert Operation</h2>
               </div>
               <div class="art req" title="Demo: Heap Insert">
                  <div class="longt">
                     <h2 class="hlongt">See example of Inserting Elements into Min Heap
                     </h2>
                  </div>
                  <div class="description">
                     <p>Insert any number and see the animate swaps.</p>
                  </div>
               </div>
            </div>
            <div class="task" title="Practice: Insertion in Heaps">
               <div class="longt">
                  <h2 class="hlongt">Practice on Insert Operation</h2>
               </div>
               <div class="art req" title="Practice: Heap Insert">
                  <div class="longt">
                     <h2 class="hlongt">Practice Inserting Elements into Min Heap</h2>
                  </div>
                  <div class="description">
                     <p>The user gets to insert elements, decide on when to swap, and
                        gets instant feedback.
                     </p>
                  </div>
               </div>
            </div>
            <div class="task" title="Exercise: Building a Heap">
               <div class="longt">
                  <h2 class="hlongt">Exercise on Insert Operation</h2>
               </div>
               <div class="art req" title="Exercise: Heap Insert">
                  <div class="longt">
                     <h2 class="hlongt">Practice Inserting Elements into Min Heap</h2>
                  </div>
                  <div class="description">
                     <p>The user get to insert atleast 16 elements and decide on when the
                        elements will be swapped.
                     </p>
                  </div>
               </div>
            </div>
            <div class="quiz" title="Insert Quiz">
               <div class="longt">
                  <h2 class="hlongt">A Quiz on Insert</h2>
               </div>
               <div class="mcq">
                  <div class="preamble">
                     <div class="art txt" title="question1">
                        <div class="art-body">
                           <p>Q1. Which of the following set of numbers form a balanced
                              heap after insert heap step is performed?
                           </p>
                        </div>
                     </div>
                  </div>
                  <div class="choice" data-correct="false">
                     <div class="preamble">
                        <div class="art txt" title="q1-c1">
                           <div class="art-body">
                              <p>(A) 1, 4, 3, 9, 2, 8, 6, 7</p>
                           </div>
                        </div>
                     </div>
                  </div>
                  <div class="choice" data-correct="true">
                     <div class="preamble">
                        <div class="art txt" title="q1-c2">
                           <div class="art-body">
                              <p>(B) 2, 3, 9, 1, 6, 7, 4</p>
                           </div>
                        </div>
                     </div>
                  </div>
                  <div class="choice" data-correct="false">
                     <div class="preamble">
                        <div class="art txt" title="q1-c3">
                           <div class="art-body">
                              <p>(C) Both</p>
                           </div>
                        </div>
                     </div>
                  </div>
                  <div class="choice" data-correct="false">
                     <div class="preamble">
                        <div class="art txt" title="q1-c4">
                           <div class="art-body">
                              <p>(D) Insufficient information</p>
                           </div>
                        </div>
                     </div>
                  </div>
                  <div class="explanation">
                     <div class="art txt" title="Explanation">
                        <div class="art-body">
                           <p>A balanced heap usually has number of nodes of the form 2^n
                              -1
                           </p>
                        </div>
                     </div>
                  </div>
               </div>
               <div class="mcq">
                  <div class="preamble">
                     <div class="art txt" title="question2">
                        <div class="art-body">
                           <p>Q2. What do u think is the conplexity of inserting a heap by
                              this naive insert heap method? (Think about how and if it
                              can be further improvised)
                           </p>
                        </div>
                     </div>
                  </div>
                  <div class="choice" data-correct="true">
                     <div class="preamble">
                        <div class="art txt" title="q2-c1">
                           <div class="art-body">
                              <p>(A) n</p>
                           </div>
                        </div>
                     </div>
                  </div>
                  <div class="choice" data-correct="false">
                     <div class="preamble">
                        <div class="art txt" title="q2-c2">
                           <div class="art-body">
                              <p>(B) logn</p>
                           </div>
                        </div>
                     </div>
                  </div>
                  <div class="choice" data-correct="false">
                     <div class="preamble">
                        <div class="art txt" title="q2-c3">
                           <div class="art-body">
                              <p>(C) nlogn</p>
                           </div>
                        </div>
                     </div>
                  </div>
                  <div class="choice" data-correct="false">
                     <div class="preamble">
                        <div class="art txt" title="q2-c4">
                           <div class="art-body">
                              <p>(D) n^2</p>
                           </div>
                        </div>
                     </div>
                  </div>
                  <div class="explanation">
                     <div class="art txt" title="Explanation">
                        <div class="art-body">
                           <p>This naive method takes time of the order nlogn in worst case.
                           </p>
                        </div>
                     </div>
                  </div>
               </div>
            </div>
         </div>
         <div class="lu" title="Extract Min">
            <div class="longt">
               <h2 class="hlongt">Extract Min Operation</h2>
            </div>
            <div class="preamble">
               <div class="art txt" title="Estimation">
                  <div class="longt">
                     <h2 class="hlongt">Estimated Time</h2>
                  </div>
                  <div class="art-body">
                     <p>15 minutes</p>
                  </div>
               </div>
               <div class="art req" title="Concept of Extract Min">
                  <div class="longt">
                     <h2 class="hlongt">Extract Min Concept</h2>
                  </div>
                  <div class="description">
                     <p>Extract Min concept video should be present here
                     </p>
                  </div>
               </div>
               <div class="art txt" title="Learning Objectives">
                  <div class="longt">
                     <h2 class="hlongt">Learning Objectives of this Module:</h2>
                  </div>
                  <div class="art-body">
                     <p>Welcome to this module on extract
                        max! Take a look at what you
                        will go through in this module.
                     </p>
                     <ul>
                        <li>The steps involved in Extract Min operation</li>
                        <li>A practice exercise on Extract Min operation</li>
                        <li>A quiz to check your understanding
                           of Extract Min operation
                        </li>
                     </ul>
                  </div>
               </div>
            </div>
            <div class="task" title="Extract Min Process">
               <div class="longt">
                  <h2 class="hlongt">Process of Extracting Max Operation</h2>
               </div>
               <div class="art txt" title="Theory">
                  <div class="longt">
                     <h2 class="hlongt">Theory of Extract Min Operation</h2>
                  </div>
                  <div class="art-body">
                     <p>The root that is the top most
                        node is removed and the last
                        element is moved in its place as
                        the new root. Last element in
                        the binary tree is moved as the
                        new root and the root is placed
                        in a sorted array
                     </p>
                  </div>
               </div>
               <div class="art req" title="Image: Extract Min Representation">
                  <div class="longt">
                     <h2 class="hlongt">Pictorial Representation of Extract Min Operation</h2>
                  </div>
                  <div class="description">
                     <p>
                        A flow diagram above depicts the
                        Extract Min operation, from left
                        to right with the following
                        elements.
                     </p>
                  </div>
               </div>
               <!--div class="art req" title="Extract Min Video">
                  <div class="longt">
                     <h2 class="hlongt">Video Demonstration on Extract Min Operation</h2>
                  </div>
                  <div class="description">
                     <p></p>
                  </div>
               </div-->
            </div>
            <div class="task" title="Demo: Extract Min">
               <div class="longt">
                  <h2 class="hlongt">Demo on Extract-Min Operation</h2>
               </div>
               <div class="art req" title="Demo: Heap Extract">
                  <div class="longt">
                     <h2 class="hlongt">Demo on Extract Min Operation</h2>
                  </div>
                  <div class="description">
                     <p>Demo on Extract Min operation.</p>
                  </div>
               </div>
            </div>
            <div class="task" title="Practice: Extract Min">
               <div class="longt">
                  <h2 class="hlongt">Practice on Extract-Max Operation</h2>
               </div>
               <div class="art req" title="Practice: Heap Extract">
                  <div class="longt">
                     <h2 class="hlongt">Practice Exercise on Extract Min Operation</h2>
                  </div>
                  <div class="description">
                     <p>Practice on Extract Min operation.</p>
                  </div>
               </div>
            </div>
            <div class="task" title="Exercise: Extract Min">
               <div class="longt">
                  <h2 class="hlongt">Test on Extract-Max Operation</h2>
               </div>
               <div class="art req" title="Exercise: Heap Extract">
                  <div class="longt">
                     <h2 class="hlongt">Practice Exercise on Extract Min Operation</h2>
                  </div>
                  <div class="description">
                     <p>Exercise on Extract Min operation.</p>
                  </div>
               </div>
            </div>
            <div class="quiz" title="Extract Min Quiz">
               <div class="longt">
                  <h2 class="hlongt">A Quiz on Extract Min operation</h2>
               </div>
               <div class="mcq">
                  <div class="preamble">
                     <div class="art txt" title="question1">
                        <div class="art-body">
                           <p>Q1. What is the time complexity of the operation to remove the root?</p>
                        </div>
                     </div>
                  </div>
                  <div class="choice" data-correct="true">
                     <div class="preamble">
                        <div class="art txt" title="q1-c1">
                           <div class="art-body">
                              <p>(A) O(1)</p>
                           </div>
                        </div>
                     </div>
                  </div>
                  <div class="choice" data-correct="false">
                     <div class="preamble">
                        <div class="art txt" title="q1-c2">
                           <div class="art-body">
                              <p>(B) O(n)</p>
                           </div>
                        </div>
                     </div>
                  </div>
                  <div class="choice" data-correct="false">
                     <div class="preamble">
                        <div class="art txt" title="q1-c3">
                           <div class="art-body">
                              <p>(C) O(logn)</p>
                           </div>
                        </div>
                     </div>
                  </div>
                  <div class="choice" data-correct="false">
                     <div class="preamble">
                        <div class="art txt" title="q1-c4">
                           <div class="art-body">
                              <p>(D) Insufficient information</p>
                           </div>
                        </div>
                     </div>
                  </div>
                  <div class="explanation">
                     <div class="art txt" title="Explanation">
                        <div class="art-body">
                           <p>Explanation of question 1 for the
                              right answer.
                           </p>
                        </div>
                     </div>
                  </div>
               </div>
               <div class="mcq">
                  <div class="preamble">
                     <div class="art txt" title="question2">
                        <div class="art-body">
                           <p>Q2. How many operations will be present to remove the root if there
                              are 10 elements in an array?
                           </p>
                        </div>
                     </div>
                  </div>
                  <div class="choice" data-correct="true">
                     <div class="preamble">
                        <div class="art txt" title="q2-c1">
                           <div class="art-body">
                              <p>(A) 1</p>
                           </div>
                        </div>
                     </div>
                  </div>
                  <div class="choice" data-correct="false">
                     <div class="preamble">
                        <div class="art txt" title="q2-c2">
                           <div class="art-body">
                              <p>(B) 5</p>
                           </div>
                        </div>
                     </div>
                  </div>
                  <div class="choice" data-correct="false">
                     <div class="preamble">
                        <div class="art txt" title="q2-c3">
                           <div class="art-body">
                              <p>(C) 10</p>
                           </div>
                        </div>
                     </div>
                  </div>
                  <div class="choice" data-correct="false">
                     <div class="preamble">
                        <div class="art txt" title="q2-c4">
                           <div class="art-body">
                              <p>(D) 20</p>
                           </div>
                        </div>
                     </div>
                  </div>
                  <div class="explanation">
                     <div class="art txt" title="Explanation">
                        <div class="art-body">
                           <p>Explanation of question 2 for the
                              right answer.
                           </p>
                        </div>
                     </div>
                  </div>
               </div>
            </div>
         </div>
         <div class="lu" title="Heap Sort">
            <div class="longt">
               <h2 class="hlongt">Heap Sort</h2>
            </div>
            <div class="preamble">
               <div class="art txt" title="Estimation">
                  <div class="longt">
                     <h2 class="hlongt">Estimated Time</h2>
                  </div>
                  <div class="art-body">
                     <p>15 minutes</p>
                  </div>
               </div>
               <div class="art req" title="Concept of Heapsort">
                  <div class="longt">
                     <h2 class="hlongt">Video Demonstration on Heapsort Operation</h2>
                  </div>
                  <div class="description">
                     <p>Heapsort video should be present here</p>
                  </div>
               </div>
               <div class="art txt" title="Learning Objectives">
                  <div class="longt">
                     <h2 class="hlongt">Learning Objectives of this Module:</h2>
                  </div>
                  <div class="art-body">
                     <p>Welcome to this module on Performing the Complete Heap Sort.
                     <ul>
                        <li>A method to build heap in O(n).</li>
                        <li>A Demo on Build and Extract to perform Heap Sort.</li>
                        <li>Play around with all operations on a heap.</li>
                        <li>Quiz on Heap Sort.</li>
                     </ul>
                     </p>
                  </div>
               </div>
               <div class="art txt" title="So what is Heap Sort?">
                  <div class="longt">
                     <h2 class="hlongt">So what is Heap Sort?</h2>
                  </div>
                  <div class="art-body">
                     <p>Recall the Heap Sort is only the use of <b>insert</b> and
                        <b>extract</b> to sort an array. We have learnt both these
                        operations, now we will just use them together to get an
                        increasing array.
                     <ul>
                        <li>Insert all n elements into the heap (Build Heap).</li>
                        <li>Keep popping out the smallest element in the array.</li>
                     </ul>
                     </p>
                  </div>
               </div>
            </div>
            <div class="task" title="Fast Build-Heap Process">
               <div class="longt">
                  <h2 class="hlongt">Process of Rebuilding Heap</h2>
               </div>
               <div class="art txt" title="Theory">
                  <div class="longt">
                     <h2 class="hlongt">Theory of Rebuilding Heap</h2>
                  </div>
                  <div class="art-body">
                     <p>The root node is compared with
                        both the children and swapped
                        with the lowest child if it is
                        greater else left unchanged. This
                        process is done for all the nodes
                        until a heap is obtained.
                     </p>
                  </div>
               </div>
               <div class="art txt" title="Algorithmic Description">
                  <div class="longt">
                     <h2 class="hlongt">Algorithmic Description of Rebuilding the Heap
                        (with Max Heap)
                     </h2>
                  </div>
                  <div class="art-body">
                     <p>Rebuilding a heap is a process
                        through which we do some
                        swapping of array elements to
                        make the tree satisy the
                        heap property which is disturbed
                        by replacing the root element.
                        Rebuilding of heap takes O(logN)
                        steps and each time we ensure
                        that the parent is smaller than
                        both the children if its minheap
                        or bigger if its a maxheap.
                     </p>
                  </div>
               </div>
               <div class="art req" title="Image: Rebuild Heap Representation">
                  <div class="longt">
                     <h2 class="hlongt">Pictorial Representation of Rebuild Heap</h2>
                  </div>
                  <div class="description">
                     <p>
                        A flow diagram above depicts the
                        Rebuild operation, from left to
                        right with the following
                        elements.
                     </p>
                  </div>
               </div>
               <!--div class="art req" title="Rebuild Max Heap Video">
                  <div class="longt">
                     <h2 class="hlongt">Video Demonstration of Rebuilding Max Heap</h2>
                  </div>
                  <div class="description">
                  </div>
               </div-->
            </div>
            <div class="task" title="Demo: Complete Heap-Sort">
               <div class="longt">
                  <h2 class="hlongt">A demo of the full heap sort operation</h2>
               </div>
               <div class="art req" title="Demo: Heap Sort">
                  <div class="longt">
                     <h2 class="hlongt">Practice Exercise on Rebuild Max Heap Operation
                     </h2>
                  </div>
                  <div class="description">
                     <p>User clicks the submit button. At
                        every stage the heap structure is
                        shown using interactive JS until
                        the heap property satisies. The
                        user can also manually form the
                        tree by adding nodes to left and
                        right of the tree. If the tree
                        satisfies the heap property then
                        next number is taken as input.
                     </p>
                  </div>
               </div>
            </div>
            <div class="task" title="Practice: Play with Heaps">
               <div class="longt">
                  <h2 class="hlongt">Play with full heap sort operation</h2>
               </div>
               <div class="art req" title="Practice: Heap Sort">
                  <div class="longt">
                     <h2 class="hlongt">Practice Exercise on Heap Sort
                     </h2>
                  </div>
                  <div class="description">
                     <p>User clicks the submit button. At
                        every stage the heap structure is
                        shown using interactive JS until
                        the heap property satisies. The
                        user can also manually form the
                        tree by adding nodes to left and
                        right of the tree. If the tree
                        satisfies the heap property then
                        next number is taken as input.
                     </p>
                  </div>
               </div>
            </div>
            <div class="quiz" title="Heap Sort Quiz">
               <div class="longt">
                  <h2 class="hlongt">A Quiz on Rebuild Heap</h2>
               </div>
               <div class="mcq">
                  <div class="preamble">
                     <div class="art txt" title="question1">
                        <div class="art-body">
                           <p>Q1. What is worst case complexity of rebuild operation in a
                              heap of n elements? </p>
                        </div>
                     </div>
                  </div>
                  <div class="choice" data-correct="true">
                     <div class="preamble">
                        <div class="art txt" title="q1-c1">
                           <div class="art-body">
                              <p>(A) O(1)</p>
                           </div>
                        </div>
                     </div>
                  </div>
                  <div class="choice" data-correct="false">
                     <div class="preamble">
                        <div class="art txt" title="q1-c2">
                           <div class="art-body">
                              <p>(B) O(logn)</p>
                           </div>
                        </div>
                     </div>
                  </div>
                  <div class="choice" data-correct="false">
                     <div class="preamble">
                        <div class="art txt" title="q1-c3">
                           <div class="art-body">
                              <p>(C) O(n)</p>
                           </div>
                        </div>
                     </div>
                  </div>
                  <div class="choice" data-correct="false">
                     <div class="preamble">
                        <div class="art txt" title="q1-c4">
                           <div class="art-body">
                              <p>(D) O(nlogn)</p>
                           </div>
                        </div>
                     </div>
                  </div>
                  <div class="explanation">
                     <div class="art txt" title="Explanation">
                        <div class="art-body">
                           <p>Explanation of question 1 for the
                              right answer.
                           </p>
                        </div>
                     </div>
                  </div>
               </div>
               <div class="mcq">
                  <div class="preamble">
                     <div class="art txt" title="question2">
                        <div class="art-body">
                           <p>Q2. Does rebuild operation vary for max and min heap?</p>
                        </div>
                     </div>
                  </div>
                  <div class="choice" data-correct="true">
                     <div class="preamble">
                        <div class="art txt" title="q2-c1">
                           <div class="art-body">
                              <p>(A) True</p>
                           </div>
                        </div>
                     </div>
                  </div>
                  <div class="choice" data-correct="false">
                     <div class="preamble">
                        <div class="art txt" title="q2-c2">
                           <div class="art-body">
                              <p>(B) False</p>
                           </div>
                        </div>
                     </div>
                  </div>
                  
                  <div class="explanation">
                     <div class="art txt" title="Explanation">
                        <div class="art-body">
                           <p>Explanation of question 2 for the
                              right answer.
                           </p>
                        </div>
                     </div>
                  </div>
               </div>
            </div>
         </div>
         <div class="lu" title="Post Test">
            <div class="longt">
               <h2 class="hlongt">Post Test of the Experiment</h2>
            </div>
            <div class="preamble">
               <div class="art txt" title="Estimation">
                  <div class="longt">
                     <h2 class="hlongt">Estimated Time</h2>
                  </div>
                  <div class="art-body">
                     <p>10 minutes</p>
                  </div>
               </div>
               <div class="art txt" title="Instructions">
                  <div class="longt">
                     <h2 class="hlongt">Instructions for Post Test</h2>
                  </div>
                  <div class="art-body">
                     <p>Post Test includes questions on concepts from the
                        entire experiment. Read
                        the questions in the quiz section
                        and select the correct option
                        from the ones provided. Please
                        note that some questions may have
                        more than one correct response.
                     </p>
                  </div>
               </div>
            </div>
            <div class="quiz" title="Post Test Quiz">
               <div class="longt">
                  <h2 class="hlongt">A Quiz on Post Test</h2>
               </div>
               <div class="mcq">
                  <div class="preamble">
                     <div class="art txt" title="question1">
                        <div class="art-body">
                           <p>Q1. Which of the following sorting algorithms in its typical
                              implementation gives best performance when applied on an array
                              which is sorted or almost sorted (maximum 1 or two elements
                              are misplaced)?
                           </p>
                        </div>
                     </div>
                  </div>
                  <div class="choice" data-correct="false">
                     <div class="preamble">
                        <div class="art txt" title="q1-c1">
                           <div class="art-body">
                              <p>(A) Quick Sort</p>
                           </div>
                        </div>
                     </div>
                  </div>
                  <div class="choice" data-correct="false">
                     <div class="preamble">
                        <div class="art txt" title="q1-c2">
                           <div class="art-body">
                              <p>(B) Heap Sort</p>
                           </div>
                        </div>
                     </div>
                  </div>
                  <div class="choice" data-correct="false">
                     <div class="preamble">
                        <div class="art txt" title="q1-c3">
                           <div class="art-body">
                              <p>(C) Merge Sort</p>
                           </div>
                        </div>
                     </div>
                  </div>
                  <div class="choice" data-correct="true">
                     <div class="preamble">
                        <div class="art txt" title="q1-c4">
                           <div class="art-body">
                              <p>(D) Insertion Sort</p>
                           </div>
                        </div>
                     </div>
                  </div>
                  <div class="explanation">
                     <div class="art txt" title="Explanation">
                        <div class="art-body">
                           <p>Insertion sort takes linear time when input array is
                              sorted or almost sorted (maximum 1 or 2 elements are
                              misplaced). All
                              other sorting algorithms mentioned above will take more than
                              linear time in their typical implementation.
                           </p>
                        </div>
                     </div>
                  </div>
               </div>
               <div class="mcq">
                  <div class="preamble">
                     <div class="art txt" title="question2">
                        <div class="art-body">
                           <p>Q2. Consider a binary min heap containing n elements and
                              every node having degree 2 (i.e. full binary min heap
                              tree). What is the probability of finding the largest element
                              at the last level?
                           </p>
                        </div>
                     </div>
                  </div>
                  <div class="choice" data-correct="false">
                     <div class="preamble">
                        <div class="art txt" title="q2-c1">
                           <div class="art-body">
                              <p>(A) 1/2</p>
                           </div>
                        </div>
                     </div>
                  </div>
                  <div class="choice" data-correct="true">
                     <div class="preamble">
                        <div class="art txt" title="q2-c2">
                           <div class="art-body">
                              <p>(B) 1</p>
                           </div>
                        </div>
                     </div>
                  </div>
                  <div class="choice" data-correct="false">
                     <div class="preamble">
                        <div class="art txt" title="q2-c3">
                           <div class="art-body">
                              <p>(C) 1/n</p>
                           </div>
                        </div>
                     </div>
                  </div>
                  <div class="choice" data-correct="false">
                     <div class="preamble">
                        <div class="art txt" title="q2-c4">
                           <div class="art-body">
                              <p>(D) 1/2^n</p>
                           </div>
                        </div>
                     </div>
                  </div>
                  <div class="explanation">
                     <div class="art txt" title="Explanation">
                        <div class="art-body">
                           <p>Basics of min heap
                           </p>
                        </div>
                     </div>
                  </div>
               </div>
               <div class="mcq">
                  <div class="preamble">
                     <div class="art txt" title="question3">
                        <div class="art-body">
                           <p>Q3. In a max-heap, element with the greatest key is always in
                              the which node?
                           </p>
                        </div>
                     </div>
                  </div>
                  <div class="choice" data-correct="false">
                     <div class="preamble">
                        <div class="art txt" title="q2-c1">
                           <div class="art-body">
                              <p>(A) Leaf node</p>
                           </div>
                        </div>
                     </div>
                  </div>
                  <div class="choice" data-correct="false">
                     <div class="preamble">
                        <div class="art txt" title="q2-c2">
                           <div class="art-body">
                              <p>(B) First node of left sub tree
                              </p>
                           </div>
                        </div>
                     </div>
                  </div>
                  <div class="choice" data-correct="true">
                     <div class="preamble">
                        <div class="art txt" title="q2-c3">
                           <div class="art-body">
                              <p>(C) Root node</p>
                           </div>
                        </div>
                     </div>
                  </div>
                  <div class="choice" data-correct="false">
                     <div class="preamble">
                        <div class="art txt" title="q2-c4">
                           <div class="art-body">
                              <p>(D) First node of right sub tree
                              </p>
                           </div>
                        </div>
                     </div>
                  </div>
                  <div class="explanation">
                     <div class="art txt" title="Explanation">
                        <div class="art-body">
                           <p>This is one of the property of max-heap that root node must
                              have key greater than its children
                           </p>
                        </div>
                     </div>
                  </div>
               </div>
               <div class="mcq">
                  <div class="preamble">
                     <div class="art txt" title="question4">
                        <div class="art-body">
                           <p>Q4. Heap can also be used as _______.</p>
                        </div>
                     </div>
                  </div>
                  <div class="choice" data-correct="true">
                     <div class="preamble">
                        <div class="art txt" title="q2-c1">
                           <div class="art-body">
                              <p>(A) Priority queue</p>
                           </div>
                        </div>
                     </div>
                  </div>
                  <div class="choice" data-correct="false">
                     <div class="preamble">
                        <div class="art txt" title="q2-c2">
                           <div class="art-body">
                              <p>(B) Stack</p>
                           </div>
                        </div>
                     </div>
                  </div>
                  <div class="choice" data-correct="false">
                     <div class="preamble">
                        <div class="art txt" title="q2-c3">
                           <div class="art-body">
                              <p>(C) A decreasing order array</p>
                           </div>
                        </div>
                     </div>
                  </div>
                  <div class="choice" data-correct="false">
                     <div class="preamble">
                        <div class="art txt" title="q2-c4">
                           <div class="art-body">
                              <p>(D) None of the these</p>
                           </div>
                        </div>
                     </div>
                  </div>
                  <div class="explanation">
                     <div class="art txt" title="Explanation">
                        <div class="art-body">
                           <p>The property of heap that the value of root must be either
                              greater or less than both of its children makes it work like a
                              priority queue.
                           </p>
                        </div>
                     </div>
                  </div>
               </div>
               <div class="mcq">
                  <div class="preamble">
                     <div class="art txt" title="question5">
                        <div class="art-body">
                           <p>Q5. An array consist of n elements. We want to create a heap
                              using the elements. The time complexity of inserting a heap
                              will be in order of ________.
                           </p>
                        </div>
                     </div>
                  </div>
                  <div class="choice" data-correct="false">
                     <div class="preamble">
                        <div class="art txt" title="q2-c1">
                           <div class="art-body">
                              <p>(A) O(n*n*logn)</p>
                           </div>
                        </div>
                     </div>
                  </div>
                  <div class="choice" data-correct="true">
                     <div class="preamble">
                        <div class="art txt" title="q2-c2">
                           <div class="art-body">
                              <p>(B) O(n)</p>
                           </div>
                        </div>
                     </div>
                  </div>
                  <div class="choice" data-correct="false">
                     <div class="preamble">
                        <div class="art txt" title="q2-c3">
                           <div class="art-body">
                              <p>(C) O(n*n)</p>
                           </div>
                        </div>
                     </div>
                  </div>
                  <div class="choice" data-correct="false">
                     <div class="preamble">
                        <div class="art txt" title="q2-c4">
                           <div class="art-body">
                              <p>(D) O(n *logn *logn)</p>
                           </div>
                        </div>
                     </div>
                  </div>
                  <div class="explanation">
                     <div class="art txt" title="Explanation">
                        <div class="art-body">
                           <p>Inserting a heap requires O(n) time as number of comparisons
                              are n+n/2 + n/4 .. which forms a GP and when you sum it, it is in the 
                              form of O(n).
                           </p>
                        </div>
                     </div>
                  </div>
               </div>
            </div>
         </div>
        <!--  <div class="lu" title="Feedback">
            <div class="longt">
               <h2 class="hlongt">Feedback of the Experiment</h2>
            </div>
            <div class="preamble">
               <div class="art txt" title="Feedback Form">
                  <div class="longt">
                     <h2 class="hlongt">Feedback Form of the Experiment</h2>
                  </div>
                  <div class="art-body">
                     <p>The experiment ends here,thanks
                        for participating! Please fill
                        up the form.
                     </p>
                  </div>
               </div>
            </div>
         </div> -->
         <div class="lu" title="Further Readings/References">
            <div class="longt">
               <h2 class="hlongt">Further Readings/References of the Experiment</h2>
            </div>
            <div class="preamble">
               <div class="art txt" title="Explore">
                  <div class="longt">
                     <h2 class="hlongt">Explore More About Heapsort</h2>
                  </div>
                  <div class="art-body">
                     <p>You can explore more about
                        Heapsort Experiment through
                        following resources:
                     </p>
                     <p>
                     <h4>Interactive Modules</h4>
                     <ul>
                        <li><a
                           href="https://opendsa-server.cs.vt.edu/ODSA/Books/Everything/html/Heapsort.html">Flash
                           Module</a>
                        </li>
                        <li><a
                           href="https://www.studytonight.com/data-structures/heap-sort">Concept
                           Explanation</a>
                        </li>
                        <li><a href="https://www.programiz.com/dsa/heap-sort">Insert,
                           Remove root and Replace, rebuild :</a>
                        </li>
                        <li><a href="https://www.geeksforgeeks.org/heap-sort/">Heapsort
                           Implementation</a>
                        </li>
                     </ul>
                     </p>
                     <p>
                     <h4>Applications</h4>
                     <ul>
                        <li><a
                           href="https://www.geeksforgeeks.org/applications-of-heap-data-structure/">Applications
                           of heap data structure</a>
                        </li>
                        <li><a
                           href="https://ocw.mit.edu/courses/electrical-engineering-and-computer-science/6-006-introduction-to-algorithms-fall-2011/lecture-videos/MIT6_006F11_lec04.pdf">University
                           Document</a>
                        </li>
                        <li><a
                           href="https://www.quora.com/What-are-practical-applications-of-the-HEAP-algorithms">Quora
                           Answer</a>
                        </li>
                        <li><a
                           href="https://softwareengineering.stackexchange.com/questions/194258/applications-of-heapsort">Stack
                           Overflow</a>
                        </li>
                     </ul>
                     </p>
                     <p>
                     <h4>Quizzes</h4>
                     <ul>
                        <li><a
                           href="https://www.geeksforgeeks.org/data-structure-gq/heap-gq/">MCQ
                           Quiz</a>
                        </li>
                        <li><a
                           href="https://www.hackerrank.com/contests/hw1/challenges/heap-sort/">HackerRank
                           Basic Questions</a>
                        </li>
                        <li><a href="https://brilliant.org/practice/heap-sort/">Online
                           Quiz</a>
                        </li>
                        <li><a
                           href="https://www.hackerearth.com/practice/algorithms/sorting/heap-sort/practice-problems/">Practice
                           Questions</a>
                        </li>
                        <li><a
                           href="https://www.sanfoundry.com/data-structure-questions-answers-heap/">Subjective
                           Questions</a>
                        </li>
                     </ul>
                     </p>
                  </div>
               </div>
            </div>
         </div>
      </div>
      <script src="./js/loader.js"></script>
   </body>
</html>

